variables:
  _flow_provision_src_format: "https://gitlab.com/gxmmx/gitops/flowwork/-/raw/main/src/provision/provision_format.sh"
  _flow_provision_src_validate: "https://gitlab.com/gxmmx/gitops/flowwork/-/raw/main/src/provision/provision_validate.sh"
  _flow_provision_src_provision: "https://gitlab.com/gxmmx/gitops/flowwork/-/raw/main/src/provision/provision.sh"
  _flow_provision_img_provision: "$CI_TEMPLATE_REGISTRY_HOST/gitlab-org/terraform-images/stable:latest"

  TF_ROOT: "${_flow_provision_path}"
  TF_STATE_NAME: "${FLOW_ENVIRONMENT_SLUG}"


format provision:
  stage: validate
  image: $_flow_provision_img_provision
  dependencies: []
  before_script:
    - apk add wget
    - wget -q -O /usr/bin/flow-common "$_flow_common_sh_src"
    - wget -q -O /usr/bin/flow-provision "$_flow_provision_src_format"
    - chmod +x /usr/bin/flow-provision
  script:
    - /usr/bin/flow-provision format
  rules:
    - if: $CI_PIPELINE_SOURCE != 'merge_request_event'
      when: never
    - if: $_flow_provision != "true"
      when: never
    - if: $_flow_provision_validate != "true"
      when: never
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_prod_branch && $_flow_prod_provision == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env1_branch && $_flow_env1_provision == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env2_branch && $_flow_env2_provision == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env3_branch && $_flow_env3_provision == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env4_branch && $_flow_env4_provision == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env5_branch && $_flow_env5_provision == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env6_branch && $_flow_env6_provision == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env7_branch && $_flow_env7_provision == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env8_branch && $_flow_env8_provision == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env9_branch && $_flow_env9_provision == 'true'
  artifacts:
    name: "$CI_JOB_NAME_SLUG - $CI_COMMIT_SHORT_SHA on $CI_COMMIT_REF_SLUG"
    expire_in: 1 day
    public: false
    paths:
      - $_flow_reports_path
    reports:
      codequality: ${_flow_reports_path}/codequality/${_flow_report_provision_format}


validate provision:
  stage: validate
  image: $_flow_provision_img_provision
  dependencies: []
  before_script:
    - apk add wget
    - wget -q -O /usr/bin/flow-provision "$_flow_provision_src_validate"
    - chmod +x /usr/bin/flow-provision
  script:
    - /usr/bin/flow-provision validate
  rules:
    - if: $CI_PIPELINE_SOURCE != 'merge_request_event'
      when: never
    - if: $_flow_provision != "true"
      when: never
    - if: $_flow_provision_validate != "true"
      when: never
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_prod_branch && $_flow_prod_provision == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env1_branch && $_flow_env1_provision == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env2_branch && $_flow_env2_provision == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env3_branch && $_flow_env3_provision == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env4_branch && $_flow_env4_provision == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env5_branch && $_flow_env5_provision == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env6_branch && $_flow_env6_provision == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env7_branch && $_flow_env7_provision == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env8_branch && $_flow_env8_provision == 'true'
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == $_flow_env9_branch && $_flow_env9_provision == 'true'
  artifacts:
    name: "$CI_JOB_NAME_SLUG - $CI_COMMIT_SHORT_SHA on $CI_COMMIT_REF_SLUG"
    expire_in: 1 day
    public: false
    paths:
      - $_flow_reports_path
    reports:
      codequality: ${_flow_reports_path}/codequality/${_flow_report_provision_validate}


prepare provision:
  stage: prepare
  image: $_flow_provision_img_provision
  dependencies: []
  before_script:
    - apk add wget
    - wget -q -O /usr/bin/flow-provision "$_flow_provision_src_provision"
    - chmod +x /usr/bin/flow-provision
  script:
    - /usr/bin/flow-provision prepare
  rules:
    - if: $CI_PIPELINE_SOURCE == 'merge_request_event'
      when: never
    - if: $_flow_provision != "true"
      when: never
    - if: $CI_COMMIT_BRANCH == $_flow_prod_branch && $_flow_prod_provision == 'true'
    - if: $CI_COMMIT_BRANCH == $_flow_env1_branch && $_flow_env1_provision == 'true'
    - if: $CI_COMMIT_BRANCH == $_flow_env2_branch && $_flow_env2_provision == 'true'
    - if: $CI_COMMIT_BRANCH == $_flow_env2_branch && $_flow_env3_provision == 'true'
    - if: $CI_COMMIT_BRANCH == $_flow_env2_branch && $_flow_env4_provision == 'true'
    - if: $CI_COMMIT_BRANCH == $_flow_env2_branch && $_flow_env5_provision == 'true'
    - if: $CI_COMMIT_BRANCH == $_flow_env2_branch && $_flow_env6_provision == 'true'
    - if: $CI_COMMIT_BRANCH == $_flow_env2_branch && $_flow_env7_provision == 'true'
    - if: $CI_COMMIT_BRANCH == $_flow_env2_branch && $_flow_env8_provision == 'true'
    - if: $CI_COMMIT_BRANCH == $_flow_env2_branch && $_flow_env9_provision == 'true'

  resource_group: ${TF_STATE_NAME}
  cache:
    key: "${TF_ROOT}"
    paths:
      - ${TF_ROOT}/.terraform/
  artifacts:
    name: "$CI_JOB_NAME_SLUG - $CI_COMMIT_SHORT_SHA on $CI_COMMIT_REF_SLUG"
    expire_in: 1 day
    public: false
    paths:
      - ${TF_ROOT}/plan.cache
      - $_flow_reports_path
    reports:
      terraform: ${TF_ROOT}/plan.json
      dotenv: ${_flow_reports_path}/provision/${_flow_report_provision_envvars}
  environment:
    name: ${_flow_environment_name}
    url: "${FLOW_URL}"
    action: prepare


provision environment:
  stage: provision
  image: $_flow_provision_img_provision
  before_script:
    - apk add wget
    - wget -q -O /usr/bin/flow-provision "$_flow_provision_src_provision"
    - chmod +x /usr/bin/flow-provision
  script:
    - /usr/bin/flow-provision provision
  rules:
    - if: $CI_PIPELINE_SOURCE == 'merge_request_event'
      when: never
    - if: $_flow_provision != "true"
      when: never
    - if: $CI_COMMIT_BRANCH == $_flow_prod_branch && $_flow_prod_provision == 'true' && $_flow_prod_provision_manual != 'true'
    - if: $CI_COMMIT_BRANCH == $_flow_prod_branch && $_flow_prod_provision == 'true' && $_flow_prod_provision_manual == 'true'
      when: manual
    - if: $CI_COMMIT_BRANCH == $_flow_env1_branch && $_flow_env1_provision == 'true'
    - if: $CI_COMMIT_BRANCH == $_flow_env2_branch && $_flow_env2_provision == 'true'
    - if: $CI_COMMIT_BRANCH == $_flow_env2_branch && $_flow_env3_provision == 'true'
    - if: $CI_COMMIT_BRANCH == $_flow_env2_branch && $_flow_env4_provision == 'true'
    - if: $CI_COMMIT_BRANCH == $_flow_env2_branch && $_flow_env5_provision == 'true'
    - if: $CI_COMMIT_BRANCH == $_flow_env2_branch && $_flow_env6_provision == 'true'
    - if: $CI_COMMIT_BRANCH == $_flow_env2_branch && $_flow_env7_provision == 'true'
    - if: $CI_COMMIT_BRANCH == $_flow_env2_branch && $_flow_env8_provision == 'true'
    - if: $CI_COMMIT_BRANCH == $_flow_env2_branch && $_flow_env9_provision == 'true'
  resource_group: ${TF_STATE_NAME}
  cache:
    key: "${TF_ROOT}"
    paths:
      - ${TF_ROOT}/.terraform/
  artifacts:
    name: "$CI_JOB_NAME_SLUG - $CI_COMMIT_SHORT_SHA on $CI_COMMIT_REF_SLUG"
    expire_in: 1 day
    public: false
    paths:
      - $_flow_reports_path
  environment:
    name: ${_flow_environment_name}
    url: "${FLOW_URL}"
    action: start
    on_stop: destroy environment


destroy environment:
  stage: provision
  image: $_flow_provision_img_provision
  before_script:
    - apk add wget
    - wget -q -O /usr/bin/flow-provision "$_flow_provision_src_provision"
    - chmod +x /usr/bin/flow-provision
  script:
    - /usr/bin/flow-provision destroy
  rules:
    - if: $CI_PIPELINE_SOURCE == 'merge_request_event'
      when: never
    - if: $_flow_provision != "true"
      when: never
    # Prod
    - if: $CI_COMMIT_BRANCH == $_flow_prod_branch && $_flow_prod_provision == 'true'
      when: manual
    - if: $CI_COMMIT_BRANCH == $_flow_env1_branch && $_flow_env1_provision == 'true'
      when: manual
    - if: $CI_COMMIT_BRANCH == $_flow_env2_branch && $_flow_env2_provision == 'true'
      when: manual
    - if: $CI_COMMIT_BRANCH == $_flow_env2_branch && $_flow_env3_provision == 'true'
      when: manual
    - if: $CI_COMMIT_BRANCH == $_flow_env2_branch && $_flow_env4_provision == 'true'
      when: manual
    - if: $CI_COMMIT_BRANCH == $_flow_env2_branch && $_flow_env5_provision == 'true'
      when: manual
    - if: $CI_COMMIT_BRANCH == $_flow_env2_branch && $_flow_env6_provision == 'true'
      when: manual
    - if: $CI_COMMIT_BRANCH == $_flow_env2_branch && $_flow_env7_provision == 'true'
      when: manual
    - if: $CI_COMMIT_BRANCH == $_flow_env2_branch && $_flow_env8_provision == 'true'
      when: manual
    - if: $CI_COMMIT_BRANCH == $_flow_env2_branch && $_flow_env9_provision == 'true'
      when: manual
  allow_failure: true
  resource_group: ${TF_STATE_NAME}
  cache:
    key: "${TF_ROOT}"
    paths:
      - ${TF_ROOT}/.terraform/
  environment:
    name: ${_flow_environment_name}
    action: stop
